﻿// 1.1.6.08. In the combinatorial mathematics, the Catalan numbers are calculated by the
// following formula "Cn = ... ": http://en.wikipedia.org/wiki/Catalan_number
// Write a program to calculate the N-th Catalan number by given N.

using System;

class CatalansNumbers
{
    static void Main()
    {
        Begin:
        int catalansMember = int.Parse(Console.ReadLine());     // there is a bug for 0 and int32 overflows after the 6-th member

        int dividend = 2 * catalansMember;
        int firstDivisor = catalansMember + 1;
        int secondDivisor = catalansMember;

        for (int dividendFactorialCounter = dividend - 1, dividendCalculations = dividend; dividendFactorialCounter > 1; dividendFactorialCounter--)
        {
            dividendCalculations *= dividendFactorialCounter;
            if (dividendFactorialCounter == 2)
            {
                dividend = dividendCalculations;
            }
        }
        for (int divisorFactorialCounter = firstDivisor - 1, divisorCalculations = firstDivisor; divisorFactorialCounter > 1; divisorFactorialCounter--)
        {
            divisorCalculations *= divisorFactorialCounter;
            if (divisorFactorialCounter == 2)
            {
                firstDivisor = divisorCalculations;
            }
        }
        for (int divisorFactorialCounter = secondDivisor - 1, divisorCalculations = secondDivisor; divisorFactorialCounter > 1; divisorFactorialCounter--)
        {
            divisorCalculations *= divisorFactorialCounter;
            if (divisorFactorialCounter == 2)
            {
                secondDivisor = divisorCalculations;
            }
        }

        Console.WriteLine(dividend / (firstDivisor * secondDivisor));
        goto Begin;
    }
}
