﻿// 1.1.4.12. Write a program to print the first 100 members of the
// sequence of Fibonacci: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, …

using System;
using System.Numerics;

class FibonacciMembers
{
    static void Main()
    {
        BigInteger firstFibNum = 0;
        BigInteger secondFibNum = 1;
        BigInteger thirdFibNum = 1;
        for (int i = 1; i <= 33; i++)
        {
            Console.Write(firstFibNum + " " + secondFibNum + " " + thirdFibNum + " ");
            firstFibNum = secondFibNum + thirdFibNum;
            secondFibNum = thirdFibNum + firstFibNum;
            thirdFibNum = firstFibNum + secondFibNum;
        }
        Console.WriteLine();

        // //another solution of the problem:
        // int oddFibMember = 0;    
        // int evenFibMember = 1;
        // for (int fibMember = 1; fibMember <= 100; fibMember++)
        // {
        //     if (fibMember % 2 != 0)
        //     {
        //         Console.WriteLine(oddFibMember);
        //         oddFibMember += evenFibMember;
                 
        //     }
        //     else
        //     {
        //         Console.WriteLine(evenFibMember);
        //         evenFibMember += oddFibMember;
                 
        //     }
        //}
    }
}