﻿using System;

public static class MaxIncreasingSequence
{
    static void Main()
    {
        int[] arr = { 9, 6, 2, 7, 4, 7, 5, 6, 7, 8, 4 };
        int[] len = new int[arr.Length];

        Console.WriteLine("Array: { 9, 6, 2, 7, 4, 7, 5, 6, 7, 8, 4 } ");
        Console.WriteLine();

        len[0] = 1;
        int indexOfBiggestSubset = 0;
        for (int x = 0; x < arr.Length; x++)
        {
            Console.WriteLine("{0}: At element {1}", x, arr[x]);
            // По начало максималната дължина е 1
            len[x] = 1;


            // Търсим в предишните елементи за по-малък по стойност
            for (int i = 0; i < x; i++)
            {
                // Първата проверка намира по-малък елемент, а втората проверя дали с този елемент може да бъде образувана
                // по-голяма поредица от вече съществуващата
                if (arr[i] < arr[x])
                {
                    if (len[i] + 1 > len[x])
                    {
                        len[x] = len[i] + 1;  // Записваме дължината на намераната последователност на х със елементът i
                    }


                    // Тук ще онагледя как работи кодът: (това не е част от решението)
                    Console.WriteLine("Found smaller element:  {0} -> {1}", arr[x], arr[i]);
                    Console.WriteLine("The new sequence is {0} with the sequence at {1}", arr[x], arr[i]);
                    Console.Write("Sequence: {0} ", arr[x]);
                    arr.PrintSequenceAtIndex(i);
                    Console.WriteLine();
                    Console.WriteLine();
                }
            }

            // Проверка дали това е най-голямата последователност до момента
            if (len[x] > len[indexOfBiggestSubset])
            {
                indexOfBiggestSubset = x;
            }
            Console.WriteLine();
        }

        Console.WriteLine("All sequences found:");
        for (int i = 0; i < arr.Length; i++)
        {
            Console.Write("{0}: number: {1} - lenght: {2}  sequence: ", i, arr[i], len[i]);
            arr.PrintSequenceAtIndex(i);
            Console.WriteLine();
        }
        Console.WriteLine();
        Console.WriteLine();
        Console.WriteLine("Longest sequence: ");
        arr.PrintSequenceAtIndex(indexOfBiggestSubset);
        Console.ReadKey();
    }

    /// <summary>
    /// Тази фукнция принтира последователността от по-малки елементи преди този на дадения индекс
    /// </summary>
    /// <param name="arr">Масива в който търсим</param>
    /// <param name="index">Индекса на елемента преди който да търсим </param>
    public static void PrintSequenceAtIndex(this int[] arr, int index)
    {
        int prevIndex = index;
        Console.Write(arr[index] + " ");

        // Вървим назад по елементите
        for (; index >= 0; index--)
        {
            if (arr[index] < arr[prevIndex])  // Проверяваме дали има по-малък елемент от последния намерен
            {
                Console.Write(arr[index] + " ");
                prevIndex = index;  // Записваме индекса на новия последен елемент
            }
        }

    }


}